(*
 Sukyoung Ryu, The LET Project, KAIST

 Copyright(c) 2001 Research On Program Analysis System
 National Creative Research Initiative Center
 Korea Advanced Institute of Science & Technology
 http://ropas.kaist.ac.kr

 All rights reserved. This file is distributed under the terms of
 an Open Source License.
*)

signature CFAINIT =
sig
val init: string list -> CfaUtils.fid * string list
end (* CFAINIT *)

structure CfaInit : CFAINIT =
struct

structure L = List
structure F = Filename
structure U = Utils
open CfaUtils

(* init: string list -> fid * string list *)
fun init files =
  let val fs = L.map (fn s =>
                         if F.check_suffix s ".n"
                         then (F.chop_extension s)^CfaFileIO.fileIOext
                         else raise U.Fail (s^" is not an nML file.")) files
      val datas = 
          L.fold_left (fn ds f =>
                          ((f, CfaFileIO.load f)::ds
                           handle CfaFileIO.Invalid_header => ds
                                | Sys_error _ => ds)) [] fs
      val datas' =
          L.sort (fn (_,({c=C(_,ci1),...},_)) (_,({c=C(_,ci2),...},_)) =>
                     compare ci1.ff ci2.ff) datas
  in  (initCfa();
       L.fold_left (fn (_,fs') (f,d as ({c=C(_,ci),...},_)) =>
                       (initCfaConstruct d; ci.lf, fs'@[f])) (0,[]) datas')
  end

end (* CfaInit *)
