(*
 Sukyoung Ryu, The LET Project, KAIST

 Copyright(c) 2001 Research On Program Analysis System
 National Creative Research Initiative Center
 Korea Advanced Institute of Science & Technology
 http://ropas.kaist.ac.kr

 All rights reserved. This file is distributed under the terms of
 an Open Source License.
*)

signature CFASOLVE =
sig
val solve: unit -> unit
end (* CFASOLVE *)

structure CfaSolve : CFASOLVE =
struct

open Utils
open CfaUtils

(* solve: unit -> unit *)
fun solve() =
  let fun iterate() =
        if (!flag)
        then (flag := false; inc count; cfasE (); cfasAp (); cfasLb ();
	      iterate ())
  in  (initCfaSolve (); fidsbytys (); iterate ();
       if (!Utils.cfa)
       then print "\n************************* nML Control Flow Analyzer *************************\n";
       if (!Utils.debugflag)
       then print ("\nCfa     : "^(i2s (!count))^" Iterations.\n"))
  end

end (* CfaSolve *)
